CREATE OR REPLACE FUNCTION addColumn() 
RETURNS VOID AS 
$BODY$ 
BEGIN 

    IF   EXISTS (SELECT 1 FROM information_schema.columns 
                    WHERE table_name= 'pdv_cx_nfce_certificado' 
                         and column_name='ativacao_sat') THEN 
						 
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN ativacao_sat SET DATA TYPE CHARACTER VARYING(20); 
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN ativacao_sat SET NOT NULL;
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN ativacao_sat SET DEFAULT '';
		RAISE NOTICE 'coluna ativacao_sat FOI alterada ';                             
    ELSE
        ALTER TABLE pdv_cx_nfce_certificado ADD COLUMN ativacao_sat CHARACTER VARYING(20) NOT NULL DEFAULT '';	
		RAISE NOTICE 'Coluna ativacao_sat na tabela pdv_cx_nfce_certificado NAO EXISTE' ; 
    END IF; 
	
    IF   EXISTS (SELECT 1 FROM information_schema.columns 
                    WHERE table_name= 'pdv_cx_nfce_certificado' 
                         and column_name='fabricante_sat') THEN 
						 
        ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN fabricante_sat SET DATA TYPE SMALLINT; 
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN fabricante_sat SET NOT NULL;
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN fabricante_sat SET DEFAULT 0;
		RAISE NOTICE 'coluna fabricante_sat FOI alterada ';                             
        
    ELSE 
		ALTER TABLE pdv_cx_nfce_certificado ADD COLUMN fabricante_sat SMALLINT NOT NULL DEFAULT 0;
		RAISE NOTICE 'Coluna fabricante_sat na tabela pdv_cx_nfce_certificado NAO EXISTE ' ; 
    END IF; 
	
	IF   EXISTS (SELECT 1 FROM information_schema.columns 
                    WHERE table_name= 'pdv_cx_nfce_certificado' 
                         and column_name='sign_sat') THEN 
						 
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN sign_sat SET DATA TYPE CHARACTER VARYING(400); 
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN sign_sat SET NOT NULL;
		ALTER TABLE pdv_cx_nfce_certificado ALTER COLUMN sign_sat SET DEFAULT 0;
        RAISE NOTICE 'coluna sign_sat FOI alterada ';                             
    ELSE 
		ALTER TABLE pdv_cx_nfce_certificado ADD COLUMN sign_sat character varying(400) not null default '';
		RAISE NOTICE 'Coluna sign_sat na tabela pdv_cx_nfce_certificado NAO EXISTE '; 
    END IF; 
	
END; 
-- fim bloco principal 
$BODY$ 
LANGUAGE plpgsql VOLATILE 
  COST 100; 
ALTER FUNCTION addColumn() OWNER TO postgres; 
SELECT addColumn(); 
DROP FUNCTION addColumn();

