CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'pdv_vd_it' 
                  and column_name='cd_vend_lib'
	) THEN
           RAISE NOTICE 'Coluna  cd_vend_lib  na tabela  pdv_vd_it  ja existe!' ;
    ELSE
		ALTER TABLE IF EXISTS public.pdv_vd_it
				ADD COLUMN IF NOT EXISTS cd_vend_lib integer NOT NULL DEFAULT 0;
        RAISE NOTICE 'Coluna "cd_vend_lib" criada com sucesso!';
    END IF; 
    
END; 


$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();
