CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'est_arv_merc_familia' 
                  and column_name='qtde_limite_venda'
	) THEN
           RAISE NOTICE 'Coluna qtde_limite_venda na tabela est_arv_merc_familia ja existe!' ;
    ELSE
		ALTER TABLE public.est_arv_merc_familia ADD qtde_limite_venda int not null default 0;
        RAISE NOTICE 'Coluna "qtde_limite_venda" criada com sucesso!';
    END IF; 
    
END; 


$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();