CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'pdv_vd_it' 
                  and column_name='dt_hr_autorizacao_pbm'
	) THEN
           RAISE NOTICE 'Coluna dt_hr_autorizacao_pbm na tabela pdv_vd_it já existe!' ;
    ELSE
		ALTER TABLE pdv_vd_it ADD dt_hr_autorizacao_pbm VARCHAR(25) DEFAULT ''::character varying;
        RAISE NOTICE 'Coluna "dt_hr_autorizacao_pbm" criada com sucesso!';
    END IF; 
    
END; 
$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();
