CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'pdv_vd_it' 
                  and column_name='cd_projeto_ext'
	) THEN
           RAISE NOTICE 'Coluna CD_PROJETO_EXT na tabela PDV_VD_IT já existe!' ;
    ELSE
		ALTER TABLE pdv_vd_it ADD cd_projeto_ext int null;
        RAISE NOTICE 'Coluna "CD_PROJETO_EXT" criada com sucesso!';
    END IF; 
    
END; 
$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();
