CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'pdv_vd_it' 
                  and column_name='tipo_pbm'
	) THEN
           RAISE NOTICE 'Coluna TIPO_PBM na tabela PDV_VD_IT já existe!' ;
    ELSE
		ALTER TABLE pdv_vd_it ADD tipo_pbm int null;
        RAISE NOTICE 'Coluna "TIPO_PBM" criada com sucesso!';
    END IF; 
END; 
$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();
