CREATE OR REPLACE FUNCTION ADD_COLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS
                   WHERE TABLE_NAME ILIKE 'pdv_vd'
                   AND COLUMN_NAME ILIKE 'email_envio') THEN
        ALTER TABLE pdv_vd
        ADD email_envio VARCHAR(255); -- Ajuste o tamanho do campo conforme necessário
        RAISE NOTICE 'Coluna email_envio adicionada à tabela pdv_vd!';
    END IF;
    
END;
$BODY$
LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ADD_COLUMN() OWNER TO postgres;

SELECT ADD_COLUMN();

DROP FUNCTION ADD_COLUMN();
