CREATE OR REPLACE FUNCTION ADD_COLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS
                   WHERE TABLE_NAME ILIKE 'pdv_vd'
                   AND COLUMN_NAME ILIKE 'tipo_emissao') THEN
        ALTER TABLE pdv_vd
        ADD tipo_emissao INTEGER; -- Removido o valor padrão
        RAISE NOTICE 'Coluna tipo_emissao adicionada à tabela pdv_vd!';
    END IF;
    
END;
$BODY$
LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ADD_COLUMN() OWNER TO postgres;

SELECT ADD_COLUMN();

DROP FUNCTION ADD_COLUMN();
