CREATE OR REPLACE FUNCTION ADD_COLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF NOT EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS
                   WHERE TABLE_NAME ILIKE 'pdv_vd_it'
                   AND COLUMN_NAME ILIKE 'cnpj_projeto_pbm') THEN
        ALTER TABLE pdv_vd_it
        ADD cnpj_projeto_pbm VARCHAR(18); -- Ajuste o tamanho do campo conforme necessário
        RAISE NOTICE 'Coluna cnpj_projeto_pbm adicionada à tabela pdv_vd_it!';
    END IF;
    
END;
$BODY$
LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ADD_COLUMN() OWNER TO postgres;

SELECT ADD_COLUMN();

DROP FUNCTION ADD_COLUMN();
